org.apache.commons.io.filefilter

## Class WildcardFileFilter

- java.lang.Object
- - org.apache.commons.io.filefilter.AbstractFileFilter
  - - org.apache.commons.io.filefilter.WildcardFileFilter

- All Implemented Interfaces:
    FileFilter, FilenameFilter, Serializable, FileVisitor<Path>, PathMatcher, PathFilter, PathVisitor, IOFileFilter

      public class WildcardFileFilter
      extends AbstractFileFilter
      implements Serializable

  Filters files using the supplied wildcards.

  This filter selects files and directories based on one or more wildcards. Testing is case-sensitive by default, but this can be configured.

  The wildcard matcher uses the characters '?' and '*' to represent a single or multiple wildcard characters. This is the same as often found on DOS/Unix command lines. The check is case-sensitive by default. See `FilenameUtils.wildcardMatchOnSystem(String,String)` for more information.

  To build an instance, use `WildcardFileFilter.Builder`.

  For example:

  ## Using Classic IO

       File dir = FileUtils.current();
       FileFilter fileFilter = WildcardFileFilter.builder().setWildcards("*test*.java~*~").get();
       File[] files = dir.listFiles(fileFilter);
       for (String file : files) {
           System.out.println(file);
       }

  ## Using NIO

       final Path dir = PathUtils.current();
       final AccumulatorPathVisitor visitor = AccumulatorPathVisitor.withLongCounters(
           WildcardFileFilter.builder().setWildcards("*test*.java~*~").get());
       //
       // Walk one directory
       Files.walkFileTree(dir, Collections.emptySet(), 1, visitor);
       System.out.println(visitor.getPathCounters());
       System.out.println(visitor.getFileList());
       //
       visitor.getPathCounters().reset();
       //
       // Walk directory tree
       Files.walkFileTree(dir, visitor);
       System.out.println(visitor.getPathCounters());
       System.out.println(visitor.getDirList());
       System.out.println(visitor.getFileList());

  ## Deprecating Serialization

  Serialization is deprecated and will be removed in 3.0.

  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `WildcardFileFilter.Builder` Builds a new `WildcardFileFilter` instance.

  - ### Field Summary

    - ### Fields inherited from interface org.apache.commons.io.filefilter.IOFileFilter

      `EMPTY_STRING_ARRAY`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `accept(File file)` Tests to see if the file name matches one of the wildcards.
    `boolean` | `accept(File dir, String name)` Tests to see if the file name matches one of the wildcards.
    `FileVisitResult` | `accept(Path path, BasicFileAttributes attributes)` Tests to see if the file name matches one of the wildcards.
    `static WildcardFileFilter.Builder` | `builder()` Constructs a new `WildcardFileFilter.Builder`.
    `String` | `toString()` Provide a String representation of this file filter.

    - ### Methods inherited from class org.apache.commons.io.filefilter.AbstractFileFilter

      `append, append, get, handle, isDirectory, isFile, postVisitDirectory, preVisitDirectory, toDefaultFileVisitResult, toFileVisitResult, visitFile, visitFileFailed`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.commons.io.filefilter.IOFileFilter

      `and, matches, negate, or`

- - ### Method Detail

    - #### accept

          public boolean accept(File file)

      Tests to see if the file name matches one of the wildcards.
      Specified by:
        `accept` in interface `FileFilter`
      Specified by:
        `accept` in interface `IOFileFilter`
      Overrides:
        `accept` in class `AbstractFileFilter`
      Parameters:
        `file` - the file to check
      Returns:
        true if the file name matches one of the wildcards

    - #### accept

          public boolean accept(File dir,
                                String name)

      Tests to see if the file name matches one of the wildcards.
      Specified by:
        `accept` in interface `FilenameFilter`
      Specified by:
        `accept` in interface `IOFileFilter`
      Overrides:
        `accept` in class `AbstractFileFilter`
      Parameters:
        `dir` - the file directory (ignored)
        `name` - the file name
      Returns:
        true if the file name matches one of the wildcards

    - #### accept

          public FileVisitResult accept(Path path,
                                        BasicFileAttributes attributes)

      Tests to see if the file name matches one of the wildcards.
      Specified by:
        `accept` in interface `PathFilter`
      Specified by:
        `accept` in interface `IOFileFilter`
      Parameters:
        `path` - the file to check
        `attributes` - the path's basic attributes (may be null).
      Returns:
        true if the file name matches one of the wildcards.

    - #### builder

          public static WildcardFileFilter.Builder builder()

      Constructs a new `WildcardFileFilter.Builder`.
      Returns:
        a new `WildcardFileFilter.Builder`.

    - #### toString

          public String toString()

      Provide a String representation of this file filter.
      Overrides:
        `toString` in class `AbstractFileFilter`
      Returns:
        a String representation